• leetcode|最简单的一道NimGame


    You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

    Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

    For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

    题目:这是一个游戏,假设一个石头堆里有一堆石头,两个游戏者互相取,一次能取1,2,3个,不能超过3个,取走最后一个是赢家,写一个算法,你先来能赢吗?

    思路:题目加粗部分说了,假设玩家都很聪明,懂得这个游戏的最优战略,简单的分析发现,如果石头堆有4颗,你一定赢,取走两,对方只能一个,你拿最后一个,所以这个赢与否的石头数,跟4是有很大关系的,于是乎:

    public boolean canWinNim(int n) {
      return n%4 !=0;
    }

    完。。。。

  • 相关阅读:
    【[AH2017/HNOI2017]礼物】
    【[ZJOI2014]力】
    FFT抄袭笔记
    【[SCOI2015]小凸玩矩阵】
    【[SDOI2017]新生舞会】
    bzoj 3277: 串
    【[ZJOI2015]诸神眷顾的幻想乡】
    【[TJOI2017]DNA】
    【[TJOI2018]碱基序列】
    【[TJOI2018]异或】
  • 原文地址:https://www.cnblogs.com/wujunjie/p/5670136.html
Copyright © 2020-2023  润新知